
#include <mylib.h>

#include "game.h"

int POS_X;
int POS_Y;
int P;
int MODE;
BITMAP *scr1;
BITMAP *scr2;
BITMAP *screen;

void init_graphs ()
{
 FILE *fl;
 PALETTE p;

 POS_X = 0;
 POS_Y = 0;
 my_install_keyboard();

 fl = fopen ("Data/palette", "rb" );
    fread ( &p, sizeof ( PALETTE ), 1, fl );
 fclose (fl);
 my_set_palette ( p );

#ifndef USE_X11
if ( MODE == MODE_PAGEFLIP ) {
 scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
 scr2 = my_create_sub_bitmap ( GRAPHICS, 0, HEIGHT, WIDTH, HEIGHT );
} else {
 scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
 scr2 = my_create_bitmap ( WIDTH, HEIGHT );
}
 my_set_bitmap_cliping ( scr1, 10, 10, HEIGHT-20, HEIGHT-20 );
 my_set_bitmap_cliping ( scr2, 10, 10, HEIGHT-20, HEIGHT-20 );
 my_fillbox ( SCREEN, 0, 0, WIDTH, HEIGHT, 0 );
 my_fillbox ( GRAPHICS, 0, HEIGHT, WIDTH, HEIGHT, 0 );

 screen = scr2;
 P = 1;
#else
if ( MODE == MODE_PAGEFLIP ) {
 scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
 scr2 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
} else {
 scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
 scr2 = my_create_bitmap ( WIDTH, HEIGHT );
}
 my_set_bitmap_cliping ( scr1, 10, 10, HEIGHT-20, HEIGHT-20 );
 my_set_bitmap_cliping ( scr2, 10, 10, HEIGHT-20, HEIGHT-20 );
 my_fillbox ( SCREEN, 0, 0, WIDTH, HEIGHT, 0 );
 my_fillbox ( GRAPHICS, 0, HEIGHT, WIDTH, HEIGHT, 0 );

 screen = scr2;
 P = 1;
#endif
}

void exit_graphs ()
{
 my_remove_keyboard();
 my_text_mode ();
}

void switch_screens ()
{

if ( MODE == MODE_PAGEFLIP ) {
 if ( P ) {
   P = 0;
   my_scroll_screen ( 0, HEIGHT );
   screen = scr1;
 } else {
   P = 1;
   my_scroll_screen ( 0, 0 );
   screen = scr2;
 }
} else {
 my_put_bitmap ( scr1, scr2, 0, 0 );
}

}

