#include "mylib.h"

#ifndef USE_X11
#include <vga.h>
#endif

void my_vsync ()
{
#ifndef USE_X11
 vga_waitretrace();
#else
 XShmPutImage ( Xdisplay, Xwindow, Xgc, X_image, 0, 0, 0, 0, WIDTH, HEIGHT, False );
 XFlush ( Xdisplay );
 XSync ( Xdisplay, False );
#endif

}

#ifdef USE_X11
#define NUM_COLORS 256
#endif


void my_set_color ( int index, RGB *p )
{

#ifndef USE_X11
 vga_setpalette ( index, p->r, p->g, p->b );
#else
        static XColor   orig_colors[NUM_COLORS];
        XColor          curr_colors[NUM_COLORS];
        int             i;
        Colormap *fade_cmap, new_cmap;

        /* Set the requested pixels */
        for ( i=0; i<NUM_COLORS; ++i )
                orig_colors[i].pixel = i;

        /* Make a copy of the default colormap and use that in fade */
        {
                XQueryColors(Xdisplay, Xcolormap, orig_colors, NUM_COLORS);
                        new_cmap = XCreateColormap(Xdisplay,
                                DefaultRootWindow(Xdisplay),
                                DefaultVisual(Xdisplay, XDefaultScreen(Xdisplay)),                                                                AllocAll);
                        XStoreColors(Xdisplay,new_cmap,orig_colors,NUM_COLORS);
                        XSetWindowColormap(Xdisplay, Xwindow, new_cmap);
                        fade_cmap = &new_cmap;
        }
/*        XSync(Xdisplay, False); */
        memcpy(curr_colors, orig_colors, NUM_COLORS*sizeof(XColor));
                                curr_colors[index].red   =  p->r*257*4;
                                curr_colors[index].green =  p->g*257*4;
                                curr_colors[index].blue  =  p->b*257*4;
        XStoreColors (Xdisplay, *fade_cmap,
                             curr_colors, NUM_COLORS);
/*        XSync (Xdisplay, False); */
        XFreeColormap ( Xdisplay, Xcolormap );
        Xcolormap = new_cmap;
#endif
}

void my_get_color ( int index, RGB *p )
{
#ifndef USE_X11
 int r,g,b;

 vga_getpalette ( index, &r, &g, &b );

 p->r = r;
 p->g = g;
 p->b = b;
#endif

}

void my_set_palette ( PALETTE pal )
{

    my_set_palette_range ( pal, 0, 255 );

}

void my_get_palette ( PALETTE pal )
{

    my_get_palette_range ( pal, 0, 255 );

}

void my_set_palette_range ( PALETTE pal, int st, int end )
{
 int i;

 for ( i=st; i<=end; i++ )
	my_set_color ( i, &pal[i] );

}

void my_get_palette_range ( PALETTE pal, int st, int end )
{
 int i;

 for ( i=st; i<=end; i++ )
	my_get_color ( i, &pal[i] );

}

void my_fade_out ( int micsec )
{
 PALETTE P;
 int i;

 for ( i=0; i<256; i++ ) P[i].r = P[i].g = P[i].b = 0;

 my_fade_to ( P, micsec );

}

void my_fade_to ( PALETTE to, int speed )
{
 int x, i;
 PALETTE P;

 my_get_palette ( P );

 for ( ;; ) {
  x = 0;
  for ( i=0; i<256; i++ ) {
	if ( P[i].r < to[i].r ) { x=1; P[i].r++; }
	if ( P[i].r > to[i].r ) { x=1; P[i].r--; }
	if ( P[i].g < to[i].g ) { x=1; P[i].g++; }
	if ( P[i].g > to[i].g ) { x=1; P[i].g--; }
	if ( P[i].b < to[i].b ) { x=1; P[i].b++; }
	if ( P[i].b > to[i].b ) { x=1; P[i].b--; }
  }
  my_vsync();
  my_set_palette ( P );
  my_vsync();
  if ( !x ) break;
  my_usleep ( speed );
 }

}

