
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <unistd.h>
#include <mylib.h>
#include <fcntl.h>

#include "main.h"
#include "sock.h"
#include "graph.h"

int TCPsock = -1;
int UDPsock = -1;
int UDPport = -1;

struct sockaddr *sock_to;

unsigned char mem1[16000];
unsigned char mem2[16000];

void sock_init( char *host , int port )
{
  struct sockaddr_in myaddr_in;
  struct hostent *hp;
  int len;
  int i;

  memset ((char *)&myaddr_in, 0, sizeof(struct sockaddr_in));
  myaddr_in.sin_family = AF_INET;
  myaddr_in.sin_addr.s_addr = INADDR_ANY;
  myaddr_in.sin_port = htons ( port );

  hp = gethostbyname ( host );

  if ( hp == NULL ) {
        perror ( "sock_init: gethostbyname" );
        exit (0);
  }

  myaddr_in.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;

  if ( ( TCPsock = socket ( AF_INET, SOCK_STREAM, 0 ) ) < 0 ) {
     perror ("sock_init: socket");
     exit (0);
  }

  if ( connect ( TCPsock, (struct sockaddr *) &myaddr_in, sizeof ( struct sockaddr_in ) ) == -1 ) {
        perror ("sock_init: connect");
        exit (0);
  }

 memset ((char *)&myaddr_in, 0, sizeof(struct sockaddr_in));
 myaddr_in.sin_family = AF_INET;
 myaddr_in.sin_addr.s_addr = INADDR_ANY;
 myaddr_in.sin_port = 0;

 if ( ( UDPsock = socket ( AF_INET, SOCK_DGRAM, 0 ) ) < 0 ) {
        perror ("sock_init: socket");
        exit (0);
 }

 if ( bind(UDPsock, (struct sockaddr *)&myaddr_in, sizeof(struct sockaddr_in)) == -1 ) {
        perror ("CONN::create: bind");
        exit (0);
 }

 len = sizeof ( struct sockaddr_in );

 getsockname ( UDPsock, (struct sockaddr *) &myaddr_in, &len );

 UDPport = htons (myaddr_in.sin_port );

 sock_to = malloc ( sizeof ( struct sockaddr ) );
 memset ( sock_to, 0, sizeof ( struct sockaddr ) );

 ((struct sockaddr_in *)sock_to) -> sin_family = AF_INET;
 ((struct sockaddr_in *)sock_to) -> sin_port = htons ( port + 1 );
 ((struct sockaddr_in *)sock_to)->sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;

 fcntl ( UDPsock, F_GETFL, &i );
 fcntl ( UDPsock, F_SETFL, i|O_NONBLOCK );


}

int read_data ( int s, void *buf, int len )
{
 return recv ( s, buf, len, 0 );
}

int write_data ( int s, void *buf, int len )
{
 return send ( s, buf, len, 0 );
}

void get_udp ()
{
 int t, t2 = 0;
 int tt=0;
 char buf[16000];
 char buf2[16000];

 fd_set fd;
 struct timeval tv;

 again:;

 FD_ZERO (&fd);
 FD_SET ( UDPsock, &fd );

 tv.tv_sec = 0;
 tv.tv_usec = 0;

 if ( select ( UDPsock+1, &fd, NULL, NULL, &tv ) )  { 

  t = recv ( UDPsock, buf, 16000, 0 );
/*  if ( t>0 ) printf ("%d\n", t ); */
  if ( t2 && t > 0 ) send_keys ();
  if ( t > 16000 ) { printf ("HEY!\n"); t = 16000; }
  if ( t <= 0 && !t2 ) goto again;
   else if ( t <= 0 && t2 ) goto again2;
  t2 = 1;
  tt = t;
  memcpy ( buf2, buf, t );
  goto again;
  again2:;
  t = tt;
 if ( CP )
  work_comms ( buf2, t );
 else
  work_comms (buf2, t);
 if ( CP ) memcpy ( mem1, buf2, t );
        else memcpy ( mem2, buf2, t );
  return;
 } else if ( !t2 ) goto again; 
           else {goto again2; }

}

void send_udp ( void *buf, int len )
{

 sendto ( UDPsock, buf, len, 0, (struct sockaddr *) sock_to, sizeof ( struct sockaddr_in ) );

}

