
#include <stdlib.h>
#include <mylib.h>

#include "graph.h"
#include "starflow.h"

STAR *stars;
STAR *ostars;
int NR_STARS = 256;

void init_starflow()
{
int i;
STAR *tmp;
STAR *tmp2;

 stars = malloc ( sizeof ( STAR ) );
 stars->prev = NULL;
 ostars = malloc ( sizeof ( STAR ) );
 ostars->prev = NULL;

 tmp = stars;
 tmp2 = ostars;

 for ( i=0; i<NR_STARS; i++ ) {
   tmp->x = (random()%WIDTH)<<14;
   tmp->y = (random()%HEIGHT)<<14;
   tmp->speed = ((1<<14)/3)+random()%(2*((1<<14)/3));
   tmp2->x = tmp->x;
   tmp2->y = tmp->y;
   tmp2->speed = tmp->speed;
   tmp->next = malloc ( sizeof ( STAR ) );
   tmp->next->prev = tmp;
   tmp = tmp->next;
   tmp2->next = malloc ( sizeof ( STAR ) );
   tmp2->next->prev = tmp2;
   tmp2 = tmp2->next;
 }

 tmp = tmp->prev;
 free ( tmp->next );
 tmp->next = NULL;
 tmp2 = tmp2->prev;
 free ( tmp2->next );
 tmp2->next = NULL;

}

void move_draw_starflow ( int xsh, int ysh )
{
 STAR *tmp;
 STAR *tmp2;

 tmp = stars;
 tmp2 = ostars;

 while ( tmp->next != NULL ) {
   tmp2->x = tmp->x;
   tmp2->y = tmp->y;
   tmp->x += tmp->speed * xsh;
   tmp->y += tmp->speed * ysh;
   if ( tmp->x>>14 >= WIDTH ) { tmp->x -= WIDTH<<14; tmp->y = (random()%HEIGHT)<<14; }
   if ( tmp->y>>14 >= HEIGHT ) { tmp->y -= HEIGHT<<14; tmp->x = (random()%WIDTH)<<14; }
   if ( tmp->x < 0 ) { tmp->x += WIDTH<<14; tmp->y = (random()%HEIGHT)<<14; }
   if ( tmp->y < 0 ) { tmp->y += HEIGHT<<14; tmp->x = tmp->x = (random()%WIDTH)<<14; }
   my_setpixel ( scr, tmp->x>>14, tmp->y>>14, 255 );
   tmp = tmp->next;
   tmp2 = tmp2->next;
 }
}

void delete_starflow ()
{
 STAR *tmp;

 if ( MODE == MODE_DOUBLE_BUFFERING || MODE == MODE_DIRTY_RECTANGLES )
 	tmp = stars;
 else tmp = ostars;

 while ( tmp->next != NULL ) {
   my_setpixel ( scr, tmp->x>>14, tmp->y>>14, 0 );
   tmp = tmp->next;
 }

}


