
#include <mylib.h>
#include <string.h>
#include <unistd.h>

#include "main.h"
#include "graph.h"
#include "starflow.h"

int MODE = MODE_PAGE_FLIPING;

extern int W,H,M;

char MODENAME[256];
int CP = 1;		/* Current page */

BITMAP *scr;
BITMAP *scr1;
BITMAP *scr2;

void load_palette ()
{
 PALETTE p;
 FILE *fl;
 char fname[1024];

 if ( access ( PAL_FILE, F_OK ) != 0 )
   sprintf ( fname, "/usr/games/lib/gama2/%s", PAL_FILE );
  else strcpy ( fname, PAL_FILE );

 if ( ( fl = fopen ( fname, "rb" ) ) == NULL ) {
 	perror ("fopen");
 	printf ("Error opening file %s!\n", fname );
 	exit (0);
 }
   fread ( &p, sizeof ( PALETTE ), 1, fl );
 fclose (fl);

 my_set_palette ( p );

}

void init_vga ()
{

/* MODE = MODE_DOUBLE_BUFFERING;
 MODE = MODE_DIRTY_RECTANGLES; */
 MODE = M;
 mem1[0] = mem2[0] = mem1[1] = mem2[1] = -1; /* I must be idiot */
 memset ( mem1, 0, 100 );
 memset ( mem2, 0, 100 );

 my_set_gfx_mode ( AUTODETECT, W, H, W, M_256_COLORS );
 load_palette ();
 my_install_keyboard ();

 switch ( MODE ) {
 	case MODE_DIRTY_RECTANGLES:
		scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
		scr2 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
		scr = scr1;
 		break;
	case MODE_DOUBLE_BUFFERING:
		scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
		scr2 = my_create_bitmap ( WIDTH, HEIGHT );
		scr = scr2;
		break;
	case MODE_PAGE_FLIPING:
		scr1 = my_create_sub_bitmap ( GRAPHICS, 0, 0, WIDTH, HEIGHT );
		scr2 = my_create_sub_bitmap ( GRAPHICS, 0, HEIGHT, WIDTH, HEIGHT );
		my_scroll_screen ( 0, HEIGHT );
		scr = scr1;
		break;
 }

 my_fillbox ( scr1, 0, 0, WIDTH, HEIGHT, 0 );
 my_fillbox ( scr2, 0, 0, WIDTH, HEIGHT, 0 );

}

void change_screens ( void )	/* Change the screen */
{
 switch ( MODE ) {
 	case MODE_DIRTY_RECTANGLES:
		if ( CP ) {
		  CP = 0;
		} else {
		  CP = 1;
	  	}
 		break;
	case MODE_DOUBLE_BUFFERING:
		my_vsync ();
		my_put_bitmap ( scr1, scr2, 0, 0 );
		if ( CP ) {
		  CP = 0;
		} else {
		  CP = 1;
	  	}
		break;
	case MODE_PAGE_FLIPING:
		if ( CP ) {
		  my_scroll_screen ( 0, 0 );
		  CP = 0;
		  scr = scr2;
		} else {
		  my_scroll_screen ( 0, HEIGHT );
		  CP = 1;
		  scr = scr1;
		}
		my_vsync ();
		break;
 }
}

