#include <sys/farptr.h>
#include <sys/segments.h>
#include <stdio.h>
#include <dpmi.h>
#include <pc.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>

#include "vxdldr.h"
#include "vxd.h"
#include "farptrx.h"
#include "wsock.h"
#include "winsock.h"

int WSockDataSel = 0;

int WSockEntry [2];  // wsock.vxd 16 bit PM entry

__dpmi_meminfo _SocketP;
int SocketP;         // 64k selector for parameters
__dpmi_meminfo _SocketD;
int SocketD;         // 64k selector for Data
__dpmi_meminfo _SocketC;
int SocketC;         // code for callbacks

void Error (void)
{
  int a;

  for (a = 0; (WSA_ERRORS [a].ErrorNum != _Error) && (WSA_ERRORS [a].ErrorNum != -1); ++ a);

  if (_ErrorDisplay) printf ("%s\r\n", WSA_ERRORS [a].Error);
}

void CallVxD (int func)
{
  asm volatile ("pushl   %%es                    \n\
                 pushl   %%ecx                   \n\
                 popl    %%es                    \n\
                 lcall   _WSockEntry             \n\
                 andl    %%eax, 0x0000ffff       \n\
                 popl    %%es"
                 : "=a" (_Error)
                 : "a" (func), "b" (0), "c" (SocketP));

  if (_Error && (_Error != 0xffff)) Error ();
}

extern int CallBack;

void SocketInit (void)
{
  VxdLdrLoadDevice ("WSOCK.VXD");
  VxdLdrLoadDevice ("WSOCK.386");

  VxdGetEntry (WSockEntry, 0x003e);

  _SocketP.handle = 0;
  _SocketP.size = 65536;
  _SocketP.address = 0;
  __dpmi_allocate_memory (&_SocketP);

  _SocketD.handle = 0;
  _SocketD.size = 65536;
  _SocketD.address = 0;
  __dpmi_allocate_memory (&_SocketD);

  _SocketC.handle = 0;
  _SocketC.size = 65536;
  _SocketC.address = 0;
  __dpmi_allocate_memory (&_SocketC);

  SocketP = __dpmi_allocate_ldt_descriptors (1);
  SocketD = __dpmi_allocate_ldt_descriptors (1);
  SocketC = __dpmi_allocate_ldt_descriptors (1);

  __dpmi_set_segment_base_address (SocketP, _SocketP.address);
  __dpmi_set_segment_base_address (SocketD, _SocketD.address);
  __dpmi_set_segment_base_address (SocketC, _SocketC.address);

  __dpmi_set_segment_limit (SocketP, _SocketP.size);
  __dpmi_set_segment_limit (SocketD, _SocketD.size);
  __dpmi_set_segment_limit (SocketC, _SocketC.size);

  _farpokel (SocketC, 0, 0xea676690);           // nop / jmp long:long
  _farpokel (SocketC, 4, (int) (&CallBack));    // Offset
  _farpokel (SocketC, 8, _my_cs ());            // Segment

  __dpmi_set_descriptor_access_rights (SocketC, 0x00fb);

  WSockDataSel = _my_ds ();
}


socket *Socket (int AddressFamily, int SocketType, int Protocol)
{
 socket *S;
 
 S = malloc ( sizeof ( socket ) );

  _farpokel (SocketP, 0 * 4, AddressFamily);                  // Address Family
  _farpokel (SocketP, 1 * 4, SocketType);                     // Socket Type
  _farpokel (SocketP, 2 * 4, Protocol);                       // Protocol
  _farpokel (SocketP, 3 * 4, 0);                              // New Socket
  _farpokel (SocketP, 4 * 4, 0);                              // New Socket Handle

  CallVxD (0x0110);

  S->_Socket = _farpeekl (SocketP, 3 * 4);
  S->_SocketHandle = _farpeekl (SocketP, 4 * 4);
  _Error = 0;
  _ErrorDisplay = 1;

  S->AddressFamily = AddressFamily;
  S->SocketType = SocketType;
  S->Protocol = Protocol;

 return S;

}

void Connect ( socket *s, int address, int port )
{
 int AddressLength;
 struct InetAddress x;
 void *Address;

 x.family = AF_INET;
 x.port = htons ( port );
 x.address = address;

 Address = &x;
 AddressLength = sizeof ( struct InetAddress );

  _farpokel (SocketP, 0 * 4, (SocketP << 16) + (5 * 4));      // Address
  _farpokel (SocketP, 1 * 4, s->_Socket);                        // Socket
  _farpokel (SocketP, 2 * 4, AddressLength);                  // Address Length
  _farpokel (SocketP, 3 * 4, 0);                              // Apc Routine
  _farpokel (SocketP, 4 * 4, 0);                              // Apc Context

  _farpokex (SocketP, 5 * 4, Address, AddressLength);

  CallVxD (0x0103);

  _farpeekx (SocketP, 5 * 4, Address, AddressLength);

  memcpy ( &s->inet, &x, sizeof ( struct InetAddress ) );
}

int Recv ( socket *s, void *Buffer, int BufferLength, int Flags )
{
 int AddressLength = sizeof ( struct InetAddress );
 void *Address = &s->inet;

  _farpokel (SocketP, 0 * 4, SocketD << 16);                  // Buffer
  _farpokel (SocketP, 1 * 4, (SocketP << 16) + (10 * 4));     // Address
  _farpokel (SocketP, 2 * 4, s->_Socket);                        // Socket
  _farpokel (SocketP, 3 * 4, BufferLength);                   // Buffer Length
  _farpokel (SocketP, 4 * 4, Flags);                          // Flags
  _farpokel (SocketP, 5 * 4, AddressLength);                  // Address Length
  _farpokel (SocketP, 6 * 4, 0);                              // Bytes Received
  _farpokel (SocketP, 7 * 4, 0);                              // Apc Routine
  _farpokel (SocketP, 8 * 4, 0);                              // Apc Context
  _farpokel (SocketP, 9 * 4, 0);                              // Timeout

  _farpokex (SocketP, 10 * 4, Address, AddressLength);

  CallVxD (0x0109);

  _farpeekx (SocketP, 10 * 4, Address, AddressLength);
  _farpeekx (SocketD, 0, Buffer, BufferLength);

  return _farpeekl (SocketP, 6 * 4);
}

int Send ( socket *s, void *Buffer, int BufferLength, int Flags )
{
 int AddressLength = sizeof ( struct InetAddress );
 void *Address = &s->inet;

  _farpokel (SocketP, 0 * 4, SocketD << 16);                  // Buffer
  _farpokel (SocketP, 1 * 4, (SocketP << 16) + (10 * 4));     // Address
  _farpokel (SocketP, 2 * 4, s->_Socket);                        // Socket
  _farpokel (SocketP, 3 * 4, BufferLength);                   // Buffer Length
  _farpokel (SocketP, 4 * 4, Flags);                          // Flags
  _farpokel (SocketP, 5 * 4, AddressLength);                  // Address Length
  _farpokel (SocketP, 6 * 4, 0);                              // Bytes Received
  _farpokel (SocketP, 7 * 4, 0);                              // Apc Routine
  _farpokel (SocketP, 8 * 4, 0);                              // Apc Context
  _farpokel (SocketP, 9 * 4, 0);                              // Timeout

  _farpokex (SocketP, 10 * 4, Address, AddressLength);
  _farpokex (SocketD, 0, Buffer, BufferLength);

  CallVxD (0x010d);

  return _farpeekl (SocketP, 6 * 4);
}

int SendTo ( socket *s, void *Buffer, int BufferLength, int Flags, void *Address )
{
 int AddressLength = sizeof ( struct InetAddress );

  _farpokel (SocketP, 0 * 4, SocketD << 16);                  // Buffer
  _farpokel (SocketP, 1 * 4, (SocketP << 16) + (10 * 4));     // Address
  _farpokel (SocketP, 2 * 4, s->_Socket);                        // Socket
  _farpokel (SocketP, 3 * 4, BufferLength);                   // Buffer Length
  _farpokel (SocketP, 4 * 4, Flags);                          // Flags
  _farpokel (SocketP, 5 * 4, AddressLength);                  // Address Length
  _farpokel (SocketP, 6 * 4, 0);                              // Bytes Received
  _farpokel (SocketP, 7 * 4, 0);                              // Apc Routine
  _farpokel (SocketP, 8 * 4, 0);                              // Apc Context
  _farpokel (SocketP, 9 * 4, 0);                              // Timeout

  _farpokex (SocketP, 10 * 4, Address, AddressLength);
  _farpokex (SocketD, 0, Buffer, BufferLength);

  CallVxD (0x010d);

  return _farpeekl (SocketP, 6 * 4);
}

void Bind ( socket *s, void *Address )
{
 int AddressLength = sizeof ( struct InetAddress );

  _farpokel (SocketP, 0 * 4, (SocketP << 16) + (5 * 4));      // Address
  _farpokel (SocketP, 1 * 4, s->_Socket);                        // Socket
  _farpokel (SocketP, 2 * 4, AddressLength);                  // Address Length
  _farpokel (SocketP, 3 * 4, 0);                              // Apc Routine
  _farpokel (SocketP, 4 * 4, 0);                              // Apc Context

  _farpokex (SocketP, 5 * 4, Address, AddressLength);

  CallVxD (0x0101);

  _farpeekx (SocketP, 5 * 4, Address, AddressLength);

  memcpy ( &s->inet, Address, sizeof ( struct InetAddress ) );
}

void Listen (socket *s, int Backlog)
{
  _farpokel (SocketP, 0 * 4, s->_Socket);
  _farpokel (SocketP, 1 * 4, Backlog);

  CallVxD (0x0108);
}

void GetSockName (socket *s, void *Address )
{
 int AddressLength = sizeof ( struct InetAddress );
  _farpokel (SocketP, 0 * 4, (SocketP << 16) + (3 * 4));      // Address
  _farpokel (SocketP, 1 * 4, s->_Socket);                        // Socket
  _farpokel (SocketP, 2 * 4, AddressLength);                  // Address Length

  _farpokex (SocketP, 3 * 4, Address, AddressLength);

  CallVxD (0x0105);

  _farpeekx (SocketP, 3 * 4, Address, AddressLength);
}
