
#include <stdio.h>
#include <math.h>

#include "main.h"
#include "player.h"
#include "mather.h"
#include "comstuff.h"
#include "object.h"
#include "bullet.h"

int FSIN[180];
int FCOS[180];

void init_math ()
{
 int i;

 for ( i=0; i<180; i++ ) {
   FSIN[i] = 16384 * sin ( ((i*2)*M_PI)/180 );
   FCOS[i] = 16384 * cos ( ((i*2)*M_PI)/180 );
 }

}

void move_everybody ()
{
 PLAYER *p = plys;
 OBJECT *o = objs;
 BULLET *b = bults;

 while ( p->prev != NULL ) {
     p = p->prev;
     if ( p->status == S_I_G ) {
        p->x += p->angx;
        p->y += p->angy;
     }
 }

 while ( o->prev != NULL ) {
     o = o->prev;
     o->x += o->angx;
     o->y += o->angy;
 }

 while ( b->prev != NULL ) {
     b = b->prev;
     b->x += b->angx;
     b->y += b->angy;
 }

}

void rotate_vector ( VECTOR *v, int ang )
{
 long long tmpx, tmpy;

 tmpx = v->x;
 tmpy = v->y;

 v->x = ( tmpx * FCOS[ang] - tmpy * FSIN[ang] ) >> 14;
 v->y = ( tmpx * FSIN[ang] + tmpy * FCOS[ang] ) >> 14;

}

void call_speed ( PLAYER *pl, int type, int impulss )
{
     VECTOR v;
     int degr;

     degr = pl->rot;

     switch ( type ) {
     	case -1:
     	   degr = pl->rot + 90;
     	   break;
        case  1:
           degr = pl->rot;
           break;
     }

     if ( degr >= 180 ) degr -= 180;

     v.x = impulss;
     v.y = 0;
     rotate_vector ( &v, degr );
     pl->angx += v.x;
     pl->angy += v.y;
/*      if ( (pl->angx>>14) * (pl->angx>>14) + (pl->angy>>14) * (pl->angy>>14) > 100 * 100 ) {
        v.x = pl->angx;
        v.y = pl->angx;
     	pl->angx = (((pl->angx>>14) * ((10)*(10)))/( (v.x>>14) * (v.x>>14) + (v.y>>14) * (v.y>>14)))<<14;
     	pl->angy = (((pl->angy>>14) * ((10)*(10)))/( (v.x>>14) * (v.x>>14) + (v.y>>14) * (v.y>>14)))<<14;
     } */
}

void call_speed_obj ( OBJECT *pl, int type, int impulss )
{
     VECTOR v;
     int degr;

     degr = pl->rot;

     switch ( type ) {
     	case -1:
     	   degr = pl->rot + 90;
     	   break;
        case  1:
           degr = pl->rot;
           break;
     }

     if ( degr >= 180 ) degr -= 180;

     v.x = impulss;
     v.y = 0;
     rotate_vector ( &v, degr );
     pl->angx += v.x;
     pl->angy += v.y;
/*      if ( (pl->angx>>14) * (pl->angx>>14) + (pl->angy>>14) * (pl->angy>>14) > 100 * 100 ) {
        v.x = pl->angx;
        v.y = pl->angx;
     	pl->angx = (((pl->angx>>14) * ((10)*(10)))/( (v.x>>14) * (v.x>>14) + (v.y>>14) * (v.y>>14)))<<14;
     	pl->angy = (((pl->angy>>14) * ((10)*(10)))/( (v.x>>14) * (v.x>>14) + (v.y>>14) * (v.y>>14)))<<14;
     } */
}

void shoot ( PLAYER *pl, int type, int speed )
{
 VECTOR v;
 VECTOR r;

 switch ( pl->type ) {
 	case SHIP_XWING:
 		v.x = speed << 14;
 		v.y = 0;
 		rotate_vector ( &v, (pl->rot+1)>179?0:(pl->rot+1) );
 		r.x = -5;
 		r.y = -25;
 		rotate_vector ( &r, pl->rot );
 		add_bullet ( pl->x + (r.x<<14), pl->y + (r.y<<14), (pl->rot+1)>179?0:(pl->rot+1), type, v.x+pl->angx, v.y+pl->angy, 30 );
 		v.x = speed << 14;
 		v.y = 0;
 		rotate_vector ( &v, (pl->rot-1)<0?179:(pl->rot-1) );
 		r.x = -5;
 		r.y = 25;
 		rotate_vector ( &r,pl->rot );
 		add_bullet ( pl->x + (r.x<<14), pl->y + (r.y<<14), (pl->rot-1)<0?179:(pl->rot-1), type, v.x+pl->angx, v.y+pl->angy, 30 ); 
 		break;
 	case SHIP_AWING:
 		v.x = speed << 14;
 		v.y = 0;
 		rotate_vector ( &v, (pl->rot+1)>179?0:(pl->rot+1) );
 		r.x = -5;
 		r.y = -21;
 		rotate_vector ( &r, pl->rot );
 		add_bullet ( pl->x + (r.x<<14), pl->y + (r.y<<14), (pl->rot+1)>179?0:(pl->rot+1), type, v.x+pl->angx, v.y+pl->angy, 30 );
 		v.x = speed << 14;
 		v.y = 0;
 		rotate_vector ( &v, (pl->rot-1)<0?179:(pl->rot-1) );
 		r.x = -5;
 		r.y = 21;
 		rotate_vector ( &r,pl->rot );
 		add_bullet ( pl->x + (r.x<<14), pl->y + (r.y<<14), (pl->rot-1)<0?179:(pl->rot-1), type, v.x+pl->angx, v.y+pl->angy, 30 ); 
 		break;
	default:
		printf ("Error! Unknows ship %d!\n", pl->type );
		break;
 }

}

