
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "main.h"
#include "player.h"
#include "user.h"
#include "sock.h"
#include "comstuff.h"
#include "mather.h"
#include "spacenode.h"
#include "object.h"

PLAYER *plys;
int PLAYERS = 0;

void init_players ()
{

 plys = malloc ( sizeof ( PLAYER ) );
 plys->next = NULL;
 plys->prev = NULL;

}

PLAYER * add_player ()
{

 plys->next = malloc ( sizeof ( PLAYER ) );
 plys->next->prev = plys;
 plys->next->next = NULL;
 plys = plys->next;
 plys->sockudp = -1;

 PLAYERS ++;

 return plys->prev;

}

PLAYER * rem_player ( PLAYER *p )
{

 printf ("Removed player %d!\n", p->sock );
 PLAYERS --;

 if ( p->prev == NULL ) {
   PLAYER *tmp;
   tmp = p->next;
   close ( p->sock );
   if ( p->sockudp != -1 ) close ( p->sockudp );
   free ( p );
   tmp->prev = NULL;
   return tmp;
 } else {
   PLAYER *tmp1;
   PLAYER *tmp2;
   tmp1 = p->next;
   tmp2 = p->prev;
   tmp1->prev = tmp2;
   tmp2->next = tmp1;
   close ( p->sock );
   if ( p->sockudp != -1 ) close ( p->sockudp );
   free ( p );
   return tmp1;
 }
}

PLAYER * read_name ( PLAYER *pl )
{
 struct player_name_pwd pp;
 struct comfirm c;
 int e;

 e = read_data ( pl->sock, &pp, sizeof ( struct player_name_pwd ) );
 if ( e <= 0 && errno !=EWOULDBLOCK ) {
 	pl = rem_player ( pl );
 	return pl;
 } else if ( e<=0 && errno == EWOULDBLOCK ) return pl;

 pl->user = search_user ( pp.name );

 if ( pl->user == NULL ) {
   pl->user = add_user ( pp.name, pp.passwd, pp.side );
   pl->udp = pp.udp;
   pl->side = pl->user->side;
   pl->type = pl->user->ship =(random()%100)>50?SHIP_XWING:SHIP_AWING;
   printf("New: %s %s\n", pl->user->name, pl->user->passwd );
   pl->status = S_W_G;
   c.status = ST_OK;
   c.port = pl->portudp;
 } else {
   if ( strcmp ( pl->user->passwd, pp.passwd ) == 0 ) {
   pl->udp = pp.udp;
   pl->side = pl->user->side;
   pl->type = pl->user->ship;
   printf("Old: %s %s\n", pl->user->name, pl->user->passwd );
   pl->status = S_W_G;
   c.status = ST_OK;
   c.port = pl->portudp;
   } else {
    c.status = ST_W_PW;
    c.port = 0;
    printf ("Wrong passwd to %s\n", pl->user->name );
   }
 }

 if ( write_data ( pl->sock, &c, sizeof ( struct comfirm ) ) <= 0 ) {
 	pl = rem_player ( pl );
 	return pl;
 }

 return pl;

}

PLAYER * read_confirm ( PLAYER * pl )
{
 struct comfirm c;
 int e;

 e = read_data ( pl->sock, &c, sizeof ( struct comfirm ) );
 if ( e<=0 && errno != EWOULDBLOCK ) {
 	pl = rem_player ( pl );
 	return pl;
 } else if ( e <= 0 && errno == EWOULDBLOCK ) return pl;

 printf("Came confirmation %d!\n", c.status );

 switch ( c.status ) {
 	case ST_ST_G:
 		{
 		 pl->status = S_I_G;
 		 break;
 		}
	default:
		{
		 printf("Unknown comfirmation code %d!\n", c.status );
		 break;
	 	}
 }

 pl->x = nodes[pl->side]->x<<14;
 pl->y = nodes[pl->side]->y<<14;
 pl->angx = 0;
 pl->angy = 0;
 pl->rot = 0;

 return pl;
}

void act_player ( PLAYER *pl, char *buf )
{
 short b = *((short *)buf);

 if ( b & K_SHOOT ) {
 	shoot (pl, 28, 24);
 }

 if ( b & K_LEFT ) {
 	pl->rot ++;
 }

 if ( b & K_RIGHT ) {
 	pl->rot --;
 }

 if ( pl->rot < 0 ) pl->rot += 180;
 if ( pl->rot >= 180 ) pl->rot -= 180;

 if ( b & K_SP_UP ) {	/* 1 - up, -1 - down */
 	call_speed ( pl, 1, (1<<14)/6 );
 }

 if ( b & K_SP_DOWN ) {
 	call_speed ( pl, -1, (1<<14)/6 );
 }


}

PLAYER * read_requests ( PLAYER *pl )
{
 struct request *r;
 char b[256];
 int len;

 r = (struct request *)b;

 len = read_data ( pl->sock, b, 256 );
 if ( len <= 0 && errno != EWOULDBLOCK ) {
	pl = rem_player ( pl );
	return pl;
 } else if ( len<=0 && errno == EWOULDBLOCK ) return pl;

 return pl;

}

