

#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/ioctl.h>

#include "main.h"
#include "sock.h"
#include "player.h"
#include "loop.h"
#include "comstuff.h"

int TCPSOCK;
int UDPSOCK;

void sig_handler ( int v)
{
v = 0;
}

void init_tcp_socket()
{
 struct sockaddr_in myaddr_in;
 int x=1;

 memset ((char *)&myaddr_in, 0, sizeof(struct sockaddr_in));
 myaddr_in.sin_family = AF_INET;
 myaddr_in.sin_addr.s_addr = INADDR_ANY;
 myaddr_in.sin_port = htons ( GAMEPORT );

 printf ("Crawling on port %d\n", GAMEPORT );

 if ( ( TCPSOCK = socket ( AF_INET, SOCK_STREAM, 0 ) ) < 0 ) {
 	perror ("init_tcp_socket: socket");
 	exit (0);
 }

 setsockopt( TCPSOCK, SOL_SOCKET, SO_REUSEADDR,(char *) &x, sizeof(x) );

 if (bind(TCPSOCK, (struct sockaddr *)&myaddr_in, sizeof(struct sockaddr_in)) == -1) {
 	perror ("init_tcp_socket: bind");
 	exit (0);
 }

 if (listen(TCPSOCK, 5) == -1) {
 	perror ("init_tcp_socket: listen");
 	exit (0);
 }

}

int create_udp_socket(int *port)
{
 struct sockaddr_in myaddr_in;
 int len;

 memset ((char *)&myaddr_in, 0, sizeof(struct sockaddr_in));
 myaddr_in.sin_family = AF_INET;
 myaddr_in.sin_addr.s_addr = INADDR_ANY;
 myaddr_in.sin_port = 0;

 if ( ( UDPSOCK = socket ( AF_INET, SOCK_DGRAM, 0 ) ) < 0 ) {
 	perror ("init_udp_socket: socket");
 	exit (0);
 }

 if (bind(UDPSOCK, (struct sockaddr *)&myaddr_in, sizeof(struct sockaddr_in)) == -1) {
 	perror ("init_udp_socket: bind");
 	exit (0);
 }

 len = sizeof ( struct sockaddr_in );
 getsockname ( UDPSOCK, (struct sockaddr *) &myaddr_in, &len );

 *port = htons ( myaddr_in.sin_port );
 printf ("Udpport:%d\n", *port );

 return UDPSOCK;

}

void get_tcp_udp ()
{
 fd_set fd;
 struct timeval tv;
 PLAYER *tmp;

 FD_ZERO ( &fd );
 FD_SET ( TCPSOCK, &fd );

 tmp = plys;
  while ( tmp->prev != NULL ) {
   tmp = tmp->prev;
   FD_SET ( tmp->sock, &fd );
   if ( tmp->sockudp != -1 ) FD_SET ( tmp->sockudp, &fd );
  }

  tv.tv_usec = 0;
  tv.tv_sec = 0;

  if ( select ( 255, &fd, 0, 0, &tv ) ) {
    if ( FD_ISSET ( TCPSOCK, &fd ) ) {
        int     size;
        int     s;
        struct sockaddr_in peeraddr_in;
        PLAYER *p;

        memset ((char *)&peeraddr_in, 0, sizeof(struct sockaddr_in));

        s = accept  ( TCPSOCK, (struct sockaddr *)&peeraddr_in, &size );

        if ( s < 0 ) perror ("accept");

        p = add_player ();

        p->sock = s;
        p->status = S_W_N;
        p->sockudp = create_udp_socket ( &p->portudp );
        printf ("%d\n", p->portudp );
        memcpy ( &p->player_in, &peeraddr_in, sizeof(struct sockaddr_in) );

        printf("Con %s!!!\n", inet_ntoa ( peeraddr_in.sin_addr ));
    }

    tmp = plys;
    while ( tmp->prev != NULL ) {

     tmp = tmp->prev;

     if ( FD_ISSET ( tmp->sock, &fd ) ) {
                printf("ON TCP %d-l!\n", tmp->sock );
                switch ( tmp->status ) {
                	case S_W_N:
                		{
                		 tmp = read_name ( tmp );
                		 break;
                		}
			case S_W_G:
				{
				 tmp = read_confirm ( tmp );
				 break;
				}
			case S_I_G:
				{
				 tmp = read_requests ( tmp );
				 break;
				}
		}
     }

     if ( FD_ISSET ( tmp->sockudp, &fd ) ) {
        char data[1024];
        int t;

        t = recv ( tmp->sockudp, data, 1024, 0 );
        if ( t <= 0 ) perror ("recv");
        act_player ( tmp, data );

     }

    }

  }

}

int read_data ( int s, void *buf, int len )
{
 return recv ( s, buf, len, 0 );
}

int write_data ( int s, void *buf, int len )
{
 return send ( s, buf, len, 0 );
}

void send_udp ( void *buf, int len, int site, int port )
{
 struct sockaddr_in ppp;

 memset ( &ppp, 0, sizeof ( struct sockaddr_in ) );
 ppp.sin_family = AF_INET;
 ppp.sin_addr.s_addr = site;
 ppp.sin_port = htons ( port );
 sendto ( UDPSOCK, buf, len, 0, (struct sockaddr *) &ppp, sizeof ( struct sockaddr_in ) );

}

