
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "main.h"
#include "user.h"

USER *users;

void save_users ( char *fname )
{
 FILE *fl;
 USER *u = users;
 char rfname[1024];

 if ( access ( fname, F_OK ) != 0 )
 	sprintf ( rfname, "/usr/games/lib/gama2/%s", fname );
  else strcpy ( rfname, fname );

 fl = fopen ( rfname, "wb" );
 
   while ( u->prev != NULL ) {
     u = u->prev;
     fwrite ( u, sizeof ( USER ), 1, fl );
   }

 fclose (fl);

}

void load_users ( char *fname )
{
 FILE *fl;
 USER *u;
 char rfname[1024];

 if ( access ( fname, F_OK ) != 0 )
    sprintf ( rfname, "/usr/games/lib/gama2/%s", fname );
 else strcpy ( rfname, fname );

 u = malloc ( sizeof ( USER ) );

 fl = fopen ( rfname, "rb" );

 for (;;) {

  if ( fread ( u, sizeof ( USER ), 1, fl ) <= 0 ) break;

  memcpy ( users->name, u->name, 20 );
  memcpy ( users->passwd, u->passwd, 20 );
  users->exp = u->exp;
  users->side = u->side;
  users->ship = u->ship;
  users->bombs = u->bombs;

  users->next = malloc ( sizeof ( USER ) );
  users->next->prev = users;
  users = users->next;
  users->next = NULL;

 }

 free ( u );

 fclose (fl);

}

void init_users ()
{
 users = malloc ( sizeof ( USER ) );
 users->prev = NULL;
 users->next = NULL;
}

USER * add_user ( char name[25], char passwd[25], int side )
{
 users->next = malloc ( sizeof ( USER ) );
 users->next->prev = users;
 users->next->next = NULL;

 strncpy ( users->name, name, 25 );
 strncpy ( users->passwd, passwd, 25 );
 users->side = side;
 users->exp = 0;
 users->bombs = 0;
 users->ship = 0;

 users = users->next;

 return users->prev;

}

USER * del_user ( USER *p )
{

 if ( p->prev == NULL ) {
   USER *tmp;
   tmp = p->next;
   free ( p );
   tmp->prev = NULL;
   return tmp;
 } else {
   USER *tmp1;
   USER *tmp2;
   tmp1 = p->next;
   tmp2 = p->prev;
   tmp1->prev = tmp2;
   tmp2->next = tmp1;
   free ( p );
   return tmp1;
 }

}

USER * search_user ( char *name )
{
 USER *u = users;

 while ( u->prev != NULL ) {
  u = u->prev;
  if ( strncmp ( name, u->name, 25 ) == 0 ) return u;
 }

 return NULL;

}
